"""
$RCSfile: testExternalFile.py,v $
Unit tests for ExternalFile product

Author: <a href="mailto:cstrong@arielpartners.com">Craeg Strong</a>
Release: 1.0
"""

import os, sys, tempfile
execfile(os.path.join(sys.path[0], 'framework.py'))

import Zope
from Products.ExternalFile.ExternalFile import ExternalFile

class TestExternalFile(unittest.TestCase):

    def setUp(self):
        pass

    def testSimpleCreate(self):
        filename  = tempfile.mktemp('.txt')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.close()

        self._ef = ExternalFile('ascii', 'Ascii File',
                                'I am ASCII', filename)

        assert self._ef.getFilepath(None) == filename
        os.remove(filename)


    def testAsciiContentType(self):
        filename  = tempfile.mktemp('.txt')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.close()

        self._ef = ExternalFile('ascii', 'Ascii File',
                                'I am ASCII', filename)

        assert self._ef.getDisplayType() == 'ascii'
        os.remove(filename)

    def testBinaryContentType(self):
        filename  = tempfile.mktemp('.pdf')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.close()

        self._ef = ExternalFile('binary', 'Binary File',
                                'I am Binary', filename)

        assert self._ef.getDisplayType() == 'binary'
        os.remove(filename)

    def testImageContentType(self):
        filename  = tempfile.mktemp('.gif')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.close()

        self._ef = ExternalFile('image', 'Image File',
                                'I am a GIF', filename)

        assert self._ef.getDisplayType() == 'image'
        os.remove(filename)

    def testGetContents(self):
        testcontent = 'this is some test content'
        filename  = tempfile.mktemp('.txt')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.write(testcontent)
        touchfile.close()

        self._ef = ExternalFile('ascii', 'Ascii File',
                                'I am ASCII', filename)

        assert self._ef.getContents(None) == testcontent
        os.remove(filename)

    def testSetContents(self):
        testcontent  = 'this is some test content'
        testcontent2 = 'but this is totally different content'
        filename  = tempfile.mktemp('.txt')
        touchfile = open(filename, 'wb') # create zero-length file
        touchfile.write(testcontent)
        touchfile.close()

        self._ef = ExternalFile('ascii', 'Ascii File',
                                'I am ASCII', filename)

        self._ef.setContents(testcontent2, None)

        assert self._ef.getContents(None) == testcontent2
        
        os.remove(filename)

framework()
